# mongoc_database_find_collections()

## Synopsis

    mongoc_cursor_t *
    mongoc_database_find_collections (mongoc_database_t *database,
                                      const bson_t *filter,
                                      bson_error_t *error)
       BSON_GNUC_WARN_UNUSED_RESULT
       BSON_GNUC_DEPRECATED_FOR (mongoc_database_find_collections_with_opts);

## Deprecated

This function is deprecated and should not be used in new code.

Please use mongoc_database_find_collections_with_opts() instead.

## Description

Fetches a cursor containing documents, each corresponding to a collection on this database.

This function is considered a retryable read operation. Upon a transient error (a network error, errors due to replica set failover, etc.) the operation is safely retried once. If `retryreads` is false in the URI (see mongoc_uri_t) the retry behavior does not apply.

## Parameters

- `database`: A mongoc_database_t.

- `filter`: A matcher used by the server to filter the returned collections. May be `NULL`.

- `error`: An optional location for a bson_error_t or `NULL`.

## Errors

Errors are propagated via the `error` parameter.

## Returns

This function returns a newly allocated mongoc_cursor_t that should be freed with mongoc_cursor_destroy() when no longer in use, or NULL in case of error. The user must call mongoc_cursor_next() on the returned mongoc_cursor_t to execute the initial command.

In the returned cursor each result corresponds to the server’s representation of a collection in this database.

The cursor functions mongoc_cursor_set_limit(), mongoc_cursor_set_batch_size(), and mongoc_cursor_set_max_await_time_ms() have no use on the returned cursor.